diff -r f6ef988fda71 trytond/model/modelstorage.py
--- a/trytond/model/modelstorage.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/modelstorage.py	Sun Sep 23 17:30:03 2012 +0200
@@ -641,8 +548,8 @@
             def get_many2one(relation, value):
                 if not value:
                     return None
-                relation_obj = pool.get(relation)
-                res = relation_obj.search([
+                Relation = pool.get(relation)
+                res = Relation.search([
                     ('rec_name', '=', value),
                     ], limit=2)
                 if len(res) < 1:
@@ -659,10 +566,10 @@
                 if not value:
                     return None
                 res = []
-                relation_obj = pool.get(relation)
+                Relation = pool.get(relation)
                 for word in csv.reader(StringIO.StringIO(value), delimiter=',',
                         quoting=csv.QUOTE_NONE, escapechar='\\').next():
-                    res2 = relation_obj.search([
+                    res2 = Relation.search([
                         ('rec_name', '=', word),
                         ], limit=2)
                     if len(res2) < 1:
@@ -686,8 +593,8 @@
                 except Exception:
                     warn('reference_syntax_error', value, '/'.join(field))
                     return None
-                relation_obj = pool.get(relation)
-                res = relation_obj.search([
+                Relation = pool.get(relation)
+                res = Relation.search([
                     ('rec_name', '=', value),
                     ], limit=2)
                 if len(res) < 1:
@@ -724,7 +631,7 @@
                     except Exception:
                         warn('xml_id_syntax_error', word, '/'.join(field))
                         continue
-                    db_id = ir_model_data_obj.get_id(module, xml_id)
+                    db_id = ModelData.get_id(module, xml_id)
                     res_ids.append(db_id)
                 if ftype == 'many2many' and res_ids:
                     return [('set', res_ids)]
@@ -732,7 +639,7 @@
                     return '%s,%s' % (relation, str(res_ids[0]))
                 return res_ids and res_ids[0] or False
 
-            line = datas[position]
+            line = data[position]
             row = {}
             translate = {}
             todo = set()
@@ -795,7 +702,7 @@
             for field in todo:
                 newfd = pool.get(fields_def[field]['relation']
                         ).fields_get()
-                res = process_lines(self, datas, prefix + [field], newfd,
+                res = process_lines(data, prefix + [field], newfd,
                         position)
                 (newrow, max2, _) = res
                 nbrmax = max(nbrmax, max2)
@@ -803,17 +710,17 @@
                 row[field] = (reduce(lambda x, y: x or y, newrow.values()) and
                          [('create', newrow)]) or []
                 i = max2
-                while (position + i) < len(datas):
+                while (position + i) < len(data):
                     test = True
                     for j, field2 in enumerate(fields_names):
                         if len(field2) <= (prefix_len + 1) \
-                               and datas[position + i][j]:
+                               and data[position + i][j]:
                             test = False
                             break
                     if not test:
                         break
                     (newrow, max2, _) = \
-                            process_lines(self, datas, prefix + [field], newfd,
+                            process_lines(data, prefix + [field], newfd,
                                     position + i)
                     if reduce(lambda x, y: x or y, newrow.values()):
                         row[field].append(('create', newrow))
@@ -821,10 +728,10 @@
                     nbrmax = max(nbrmax, i)
             if prefix_len == 0:
                 for i in xrange(max(nbrmax, 1)):
-                    datas.pop(0)
+                    data.pop(0)
             return (row, nbrmax, translate)
 
-        ir_model_data_obj = pool.get('ir.model.data')
+        ModelData = pool.get('ir.model.data')
 
         # logger for collecting warnings for the client
         warnings = logging.Logger("import")
@@ -832,27 +739,26 @@
         warnings.addHandler(logging.StreamHandler(warning_stream))
 
         len_fields_names = len(fields_names)
-        for data in datas:
-            assert len(data) == len_fields_names
+        assert all(len(x) == len_fields_names for x in data)
         fields_names = [x.split('/') for x in fields_names]
-        fields_def = self.fields_get()
+        fields_def = cls.fields_get()
         done = 0
 
         warning = ''
-        while len(datas):
+        while len(data):
             res = {}
             try:
                 (res, _, translate) = \
-                        process_lines(self, datas, [], fields_def)
+                        process_lines(data, [], fields_def)
                 warning = warning_stream.getvalue()
                 if warning:
                     # XXX should raise Exception
                     Transaction().cursor.rollback()
                     return (-1, res, warning, '')
-                new_id = self.create(res)
+                new_id = cls.create(res)
                 for lang in translate:
                     with Transaction().set_context(language=lang):
-                        self.write(new_id, translate[lang])
+                        cls.write(new_id, translate[lang])
             except Exception, exp:
                 logger = logging.getLogger('import')
                 logger.error(exp)
@@ -864,7 +770,8 @@
             done += 1
         return (done, 0, 0, 0)
 
-    def check_xml_record(self, ids, values):
+    @classmethod
+    def check_xml_record(cls, records, values):
         """
         Check if a list of records and their corresponding fields are
         originating from xml data. This is used by write and delete
@@ -874,28 +781,21 @@
         xml. Values is the dictionary of written values. If values is
         equal to None, no field by field check is performed, False is
         returned as soon as one of the record comes from the xml.
-
-        :param ids: a list of ids or an id
-        :param values: a dictionary with field names as key and
-            written values as value
-        :return: True or False
         """
-        model_data_obj = Pool().get('ir.model.data')
+        ModelData = Pool().get('ir.model.data')
         # Allow root user to update/delete
         if Transaction().user == 0:
             return True
-        if isinstance(ids, (int, long)):
-            ids = [ids]
         with Transaction().set_user(0):
-            model_data_ids = model_data_obj.search([
-                ('model', '=', self._name),
-                ('db_id', 'in', ids),
+            model_data_ids = ModelData.search([
+                ('model', '=', cls.__name__),
+                ('db_id', 'in', map(int, records)),
                 ])
             if not model_data_ids:
                 return True
             if values == None:
                 return False
-            for line in model_data_obj.browse(model_data_ids):
+            for line in ModelData.browse(model_data_ids):
                 if not line.values:
                     continue
                 xml_values = safe_eval(line.values, {
@@ -907,84 +807,89 @@
                         return False
         return True
 
-    def check_recursion(self, ids, parent='parent'):
+    @classmethod
+    def check_recursion(cls, records, parent='parent'):
         '''
         Function that checks if there is no recursion in the tree
         composed with parent as parent field name.
-
-        :param ids: a list of ids
-        :param parent: the parent field name
-        :return: True or False
         '''
-        if parent in self._columns:
-            parent_type = self._columns[parent]._type
-        elif parent in self._inherit_fields:
-            parent_type = self._inherit_fields[parent][2]._type
+        if parent in cls._fields:
+            parent_type = cls._fields[parent]._type
+        elif parent in cls._inherit_fields:
+            parent_type = cls._inherit_fields[parent][2]._type
         else:
             raise Exception('Field %s not available on object "%s"' % \
-                    (parent, self._name))
+                    (parent, cls.__name__))
 
         if parent_type not in ('many2one', 'many2many'):
             raise Exception(
                     'Unsupported field type "%s" for field "%s" on "%s"' % \
-                    (parent_type, parent, self._name))
+                    (parent_type, parent, cls.__name__))
 
-        records = self.browse(ids)
         visited = set()
 
         for record in records:
             walked = set()
-            walker = record[parent]
+            walker = getattr(record, parent)
             while walker:
                 if parent_type == 'many2many':
                     for walk in walker:
                         walked.add(walk.id)
                         if walk.id == record.id:
                             return False
-                    walker = list(chain(*(walk[parent] for walk in walker
-                            if walk.id not in visited)))
+                    walker = list(chain(*(getattr(walk, parent)
+                                for walk in walker if walk.id not in visited)))
                 else:
                     walked.add(walker.id)
                     if walker.id == record.id:
                         return False
-                    walker = walker[parent] not in visited and walker[parent]
+                    walker = (getattr(walker, parent) not in visited
+                        and getattr(walker, parent))
             visited.update(walked)
 
         return True
 
-    def _get_error_args(self, field_name):
+    @classmethod
+    def _get_error_args(cls, field_name):
         pool = Pool()
-        model_field_obj = pool.get('ir.model.field')
-        error_args = (field_name, self._name)
-        if model_field_obj:
-            model_field_ids = model_field_obj.search([
+        ModelField = pool.get('ir.model.field')
+        error_args = (field_name, cls.__name__)
+        if ModelField:
+            model_fields = ModelField.search([
                         ('name', '=', field_name),
-                        ('model.model', '=', self._name),
+                        ('model.model', '=', cls.__name__),
                         ], limit=1)
-            if model_field_ids:
-                model_field = model_field_obj.browse(model_field_ids[0])
+            if model_fields:
+                model_field, = model_fields
                 error_args = (model_field.field_description,
                         model_field.model.name)
         return error_args
 
-    def _validate(self, ids):
+    @classmethod
+    def _validate(cls, records):
         pool = Pool()
         if (Transaction().user == 0
                 and Transaction().context.get('user')):
             with Transaction().set_user(Transaction().context.get('user')):
-                return self._validate(ids)
+                return cls._validate(cls.browse(records))
 
-        for field in self._constraints:
-            if not getattr(self, field[0])(ids):
-                self.raise_user_error(field[1])
+        def call(name):
+            method = getattr(cls, name)
+            if not hasattr(method, 'im_self') or method.im_self:
+                return method(records)
+            else:
+                return all(method(r) for r in records)
+        for field in cls._constraints:
+            if not call(field[0]):
+                cls.raise_user_error(field[1])
 
         if not 'res.user' in pool.object_name_list() \
                 or Transaction().user == 0:
             ctx_pref = {
             }
         else:
-            user_obj = pool.get('res.user')
-            ctx_pref = user_obj.get_preferences(context_only=True)
+            User = pool.get('res.user')
+            ctx_pref = User.get_preferences(context_only=True)
 
         def is_pyson(test):
             if isinstance(test, PYSON):
@@ -999,8 +904,7 @@
             return False
 
         with Transaction().set_context(ctx_pref):
-            records = self.browse(ids)
-            for field_name, field in self._columns.iteritems():
+            for field_name, field in cls._fields.iteritems():
                 if isinstance(field, fields.Function) and \
                         not field.setter:
                     continue
@@ -1009,13 +913,13 @@
                         ('many2one', 'many2many', 'one2many', 'one2one')
                     and field.domain):
                     if field._type in ('many2one', 'one2many'):
-                        relation_obj = pool.get(field.model_name)
+                        Relation = pool.get(field.model_name)
                     else:
-                        relation_obj = field.get_target()
+                        Relation = field.get_target()
                     if is_pyson(field.domain):
                         pyson_domain = PYSONEncoder().encode(field.domain)
                         for record in records:
-                            env = EvalEnvironment(record, self)
+                            env = EvalEnvironment(record, cls)
                             env.update(Transaction().context)
                             env['current_date'] = datetime.datetime.today()
                             env['time'] = time
@@ -1023,56 +927,60 @@
                             env['active_id'] = record.id
                             domain = PYSONDecoder(env).decode(pyson_domain)
                             relation_ids = []
-                            if record[field_name]:
+                            if getattr(record, field_name):
                                 if field._type in ('many2one',):
-                                    relation_ids.append(record[field_name].id)
+                                    relation_ids.append(
+                                        getattr(record, field_name).id)
                                 else:
                                     relation_ids.extend(
-                                            [x.id for x in record[field_name]])
-                            if relation_ids and not relation_obj.search([
+                                        [x.id for x in getattr(record,
+                                                field_name)])
+                            if relation_ids and not Relation.search([
                                         'AND',
                                         [('id', 'in', relation_ids)],
                                         domain,
                                         ]):
-                                self.raise_user_error(
+                                cls.raise_user_error(
                                         'domain_validation_record',
-                                        error_args=self._get_error_args(
+                                        error_args=cls._get_error_args(
                                             field_name))
                     else:
                         relation_ids = []
                         for record in records:
-                            if record[field_name]:
+                            if getattr(record, field_name):
                                 if field._type in ('many2one',):
-                                    relation_ids.append(record[field_name].id)
+                                    relation_ids.append(
+                                        getattr(record, field_name).id)
                                 else:
                                     relation_ids.extend(
-                                            [x.id for x in record[field_name]])
+                                        [x.id for x in getattr(record,
+                                                field_name)])
                         if relation_ids:
-                            find_ids = relation_obj.search([
+                            finds = Relation.search([
                                 'AND',
                                 [('id', 'in', relation_ids)],
                                 field.domain,
                                 ])
+                            find_ids = map(int, finds)
                             if not set(relation_ids) == set(find_ids):
-                                self.raise_user_error(
+                                cls.raise_user_error(
                                         'domain_validation_record',
-                                        error_args=self._get_error_args(
+                                        error_args=cls._get_error_args(
                                             field_name))
 
                 def required_test(value, field_name):
-                    if (isinstance(value,
-                                (BrowseRecordNull, type(None), type(False),
-                                    BrowseRecordList, basestring))
+                    if (isinstance(value, (type(None), type(False), list,
+                                    tuple, basestring))
                             and not value):
-                        self.raise_user_error('required_validation_record',
-                            error_args=self._get_error_args(field_name))
+                        cls.raise_user_error('required_validation_record',
+                            error_args=cls._get_error_args(field_name))
                 # validate states required
                 if field.states and 'required' in field.states:
                     if is_pyson(field.states['required']):
                         pyson_required = PYSONEncoder().encode(
                                 field.states['required'])
                         for record in records:
-                            env = EvalEnvironment(record, self)
+                            env = EvalEnvironment(record, cls)
                             env.update(Transaction().context)
                             env['current_date'] = datetime.datetime.today()
                             env['time'] = time
@@ -1080,21 +988,23 @@
                             env['active_id'] = record.id
                             required = PYSONDecoder(env).decode(pyson_required)
                             if required:
-                                required_test(record[field_name], field_name)
+                                required_test(getattr(record, field_name),
+                                    field_name)
                     else:
                         if field.states['required']:
                             for record in records:
-                                required_test(record[field_name], field_name)
+                                required_test(getattr(record, field_name),
+                                    field_name)
                 # validate required
                 if field.required:
                     for record in records:
-                        required_test(record[field_name], field_name)
+                        required_test(getattr(record, field_name), field_name)
                 # validate size
                 if hasattr(field, 'size') and field.size is not None:
                     for record in records:
                         if isinstance(field.size, PYSON):
                             pyson_size = PYSONEncoder().encode(field.size)
-                            env = EvalEnvironment(record, self)
+                            env = EvalEnvironment(record, cls)
                             env.update(Transaction().context)
                             env['current_date'] = datetime.datetime.today()
                             env['time'] = time
@@ -1103,15 +1013,16 @@
                             field_size = PYSONDecoder(env).decode(pyson_size)
                         else:
                             field_size = field.size
-                        if (len(record[field_name] or '') > field_size >= 0):
-                            self.raise_user_error(
+                        if (len(getattr(record, field_name) or '')
+                                > field_size >= 0):
+                            cls.raise_user_error(
                                 'size_validation_record',
-                                error_args=self._get_error_args(field_name))
+                                error_args=cls._get_error_args(field_name))
 
                 def digits_test(value, digits, field_name):
                     def raise_user_error():
-                        self.raise_user_error('digits_validation_record',
-                            error_args=self._get_error_args(field_name))
+                        cls.raise_user_error('digits_validation_record',
+                            error_args=cls._get_error_args(field_name))
                     if value is None:
                         return
                     if isinstance(value, Decimal):
@@ -1126,18 +1037,19 @@
                     if is_pyson(field.digits):
                         pyson_digits = PYSONEncoder().encode(field.digits)
                         for record in records:
-                            env = EvalEnvironment(record, self)
+                            env = EvalEnvironment(record, cls)
                             env.update(Transaction().context)
                             env['current_date'] = datetime.datetime.today()
                             env['time'] = time
                             env['context'] = Transaction().context
                             env['active_id'] = record.id
                             digits = PYSONDecoder(env).decode(pyson_digits)
-                            digits_test(record[field_name], digits, field_name)
+                            digits_test(getattr(record, field_name), digits,
+                                field_name)
                     else:
                         for record in records:
-                            digits_test(record[field_name], field.digits,
-                                field_name)
+                            digits_test(getattr(record, field_name),
+                                field.digits, field_name)
 
                 def format_test(value, format, field_name):
                     if not value:
@@ -1146,8 +1058,8 @@
                         value = value.time()
                     if value != datetime.datetime.strptime(
                             value.strftime(format), format).time():
-                        self.raise_user_error('time_format_validation_record',
-                            error_args=self._get_error_args(field_name))
+                        cls.raise_user_error('time_format_validation_record',
+                            error_args=cls._get_error_args(field_name))
 
                 # validate time format
                 if (field._type in ('datetime', 'time')
@@ -1155,25 +1067,27 @@
                     if is_pyson(field.format):
                         pyson_format = PYSONDecoder().encode(field.format)
                         for record in records:
-                            env = EvalEnvironment(record, self)
+                            env = EvalEnvironment(record, cls)
                             env.update(Transaction().context)
                             env['current_date'] = datetime.datetime.today()
                             env['time'] = time
                             env['context'] = Transaction().context
                             env['active_id'] = record.id
                             format = PYSONDecoder(env).decode(pyson_format)
-                            format_test(record[field_name], format, field_name)
+                            format_test(getattr(record, field_name), format,
+                                field_name)
                     else:
                         for record in records:
-                            format_test(record[field_name], field.format,
-                                field_name)
+                            format_test(getattr(record, field_name),
+                                field.format, field_name)
 
-    def _clean_defaults(self, defaults):
+    @classmethod
+    def _clean_defaults(cls, defaults):
         pool = Pool()
         vals = {}
         for field in defaults.keys():
-            fld_def = (field in self._columns) and self._columns[field] \
-                    or self._inherit_fields[field][2]
+            fld_def = (field in cls._fields) and cls._fields[field] \
+                    or cls._inherit_fields[field][2]
             if fld_def._type in ('many2one', 'one2one'):
                 if isinstance(defaults[field], (list, tuple)):
                     vals[field] = defaults[field][0]
